#include "pset_test.h"

void busy(int, unsigned long);

int main (int argc, char *argv[])
{
	int count = 1;
	int threads = 1;

	/* normal */	
	if (argc == 1) {
		busy(1, BUSY_NUM);
		return 0;
	}

	/* woops!  too many */
	if (argc > 4) {
		fprintf(stderr, "Learn to use this program!\n");
	}

	/* shift and prep for args */
	argc--; argv++;
	while (argc) {
		if (isdigit(argv[0][0])) {
			count = atoi(argv[0]);
		} else if (argv[0][0] == '-' && argv[0][1] == 't') {
			if (argc == 2) {
				threads = atoi(argv[1]);
				argc--; argv++;
			} else {
				threads = atoi(&argv[0][1]);
			}
		}
		argc--; argv++;
	}

	if (threads > 1) {
		threads--;
		while (threads-- && fork()) 
			;
	}
	busy(count, BUSY_NUM);

	return 0;
}

void busy(int count, unsigned long max)
{
        while (count--) {
                unsigned long i=0;
                while (i < max) {
                        int j = 0;
                        while (j++ < 10000000)
                                ;
                        i += 10000000;
                }
        }
}

