#include <stdio.h>
#include <linux/sysmp.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <errno.h>

#define __NR__sysmp     __NR_sysmp

static inline
_syscall5(int, sysmp, int, cmd, int, argi1, int, argi2,
          int, argi3, unsigned long, argl1)


int main() {
	int i = 0;
	int chld;

	chld = fork();
	if (chld) {
		sleep(3);
		sysmp(MP_MUSTRUN_PID, 0, chld, 0, 0L);
		perror("MP_MUSTRUN_PID");
		sleep(3);
		sysmp(MP_RUNANYWHERE_PID, chld, 0, 0, 0L);
		perror("MP_RUNANYWHERE_PID");
		wait (&i);
	} else {
		printf("Child: pid %d\n", getpid());
		while (i < 0x4fffffff) {
			int j = 0;
			while (j++ < 10000000)
				;
			i += 30000000;
			printf("%d: %d\n", getpid(), sysmp(MP_CURPROC, 0, 0, 0, 0L));
		}
	}

	return 0;
}
