#include <stdio.h>
#include <sys/sysmp.h>
#include <errno.h>

/* these are my system - yours is likely different */
#define TEST_CPU  		0
#define OTHER_CPU  		3
#define BUSY_NUM		(unsigned long)0x0fffffff
#define VERY_BUSY_NUM		(unsigned long)0x4fffffff
#define REALLY_BUSY_NUM		(unsigned long)0x8fffffff

int busy_print(int count, unsigned long max)
{
	int r = 0;
	while (count--) {
		unsigned long i=0;
                /* lets test some CPU usage */
                printf("  CPUs: ");
                while (i < max) {
                        /* do some busy work */
                        int j = 0;
                        while (j++ < 10000000)
                                ;
                        i += 10000000;
                        r = sysmp(MP_CURPROC);
                        printf("%d ", r);
			fflush(stdout);
                        if (r == TEST_CPU) {
                                /* uh oh!  our CPU got used! */
                                printf("\nERROR!!\n");
                                r = -1;
                                break;
                        }
                }
		printf("\n");
	}
	return r;
}

