#include "pset_test.h"

int main() 
{
	int ret;

	ret = sysmp(MP_CURPROC);
	printf("  before: CPU %d\n ", ret);
	fflush(stdout);

	ret = sysmp(MP_MUSTRUN, OTHER_CPU);
	perror("  result");
	printf("\n");

	ret = sysmp(MP_CURPROC);
	if (ret != OTHER_CPU) {
		printf("  ERROR! CPU %d was active after MUSTRUN", ret);
		return (-1); 
	}
	printf("  after: CPU %d\n ", ret);
	fflush(stdout);

	busy_print(1, BUSY_NUM);

	return (errno);
}
