#include <stdio.h>
#include <linux/sysmp.h>
#include <asm/unistd.h>
#include <errno.h>

#define __NR__sysmp     __NR_sysmp

static inline
_syscall5(int, sysmp, int, cmd, int, argi1, int, argi2,
          int, argi3, unsigned long, argl1)

int main() {
	int i = 0;
	int x = 0;
	
	x = sysmp(MP_CURPROC, 0, 0, 0, 0L);
	printf("CPU: %d\n ", x);
	fflush(stdout);
	sleep(2);

	printf("before\n"); fflush(stdout);
	sysmp(MP_MUSTRUN, 0, 0, 0, 0L);
	printf("after\n"); fflush(stdout);
	
	while (i < 0x00ffffff) {
		int j = 0;
		while (j++ < 10000000)
			;
		i += 10000000;
		printf("%d: %d\n", getpid(), sysmp(MP_CURPROC, 0, 0, 0, 0L));
		fflush(stdout);
	}

	return 0;
}
