#include <stdio.h>
#include <linux/sysmp.h>
#include <asm/unistd.h>
#include <errno.h>

void main() {
	int newset;
	newset = sysmp(MP_PSET, MPPS_CREATE, PSET_ID_NEW, 0);
	printf ("%d - ", newset);
	perror("result of creating 0 cpumask pset");

	printf("calling sysmp(MP_PSET, MPPS_ADD, %d, PSET_ALL_CPUS\n", newset);
	sysmp(MP_PSET, MPPS_ADD, newset, PSET_ALL_CPUS);
	perror("result of adding all CPUs");

	sysmp(MP_MUSTRUN, newset);
	perror("result of MUSTRUN");

	{ int i = 0; for (i = 0; i<0x4ffffff; i++); }

	sysmp(MP_RUNANYWHERE);
	perror("result of RUNANYWHERE");

	sysmp(MP_PSET, MPPS_REMOVE, newset, PSET_ALL_CPUS);
	perror("result of removing all CPUs");

	sysmp(MP_PSET, MPPS_DELETE, newset);
	perror("result of delete");
}
